#include "block.h"

#include <stdlib.h>

#include "signature.h"

static void block_sign(block* b);

/* --- init/destroy --- */

block* block_init(transaction *t, block *previous) {
    // TODO HERE
    // alloc a new struct, fill it and return it
    // Before returning it, don't forget to block_sign it.
	block* nouveau_bloc = malloc(sizeof(block));
	nouveau_bloc->t = t;
	nouveau_bloc->previous = previous;
	block_sign(nouveau_bloc);
	return nouveau_bloc;
}

void block_free(block* b) {
    // TODO HERE
    // free everything but not the previous block
	if (b != NULL) {
		transaction_free(b->t);
		free(b->sign);
		free(b);
	}
}

/* --- sign --- */

static void block_sign(block* b) {
    b->sign = signature_sign(b->previous->sign, b->t->source, b->t->destination, b->t->points);
}
