#ifndef TRANSACTION_H
#define TRANSACTION_H

typedef enum _maison {
    Administration,
    Gryffondor,
    Poufsouffle,
    Serdaigle,
    Serpentard
} maison;

typedef struct _transaction {
    int    points;
    maison source;
    maison destination;
} transaction;

transaction* transaction_init(int points, maison source, maison destination);
void         transaction_free(transaction *t);

#endif /* TRANSACTION_H */
