#include "signature.h"

#include <stdio.h>
#include <stdlib.h>

#include "md4.h"

char* signature_sign(char* old_sign, maison source, maison destination, int points) {
    int    data_size = 32 + 1 + 1 + MAX_POINT_SIZE; // previous node signature (32) + source (1) + destination (1) + max points size
    char*  data      = calloc(data_size + 1, sizeof(char));
    sprintf(data, "%s%01d%01d%04d", old_sign, source, destination, points);

    char*  sign = MD4(data, data_size);
    free(data);

    return sign;
}
